From a548430b765df8d18c32b9da2d38aa96adea85bc Mon Sep 17 00:00:00 2001
From: Tadashi Saito <tadashi_saito@dwango.co.jp>
Date: Wed, 16 Dec 2015 20:02:20 +0900
Subject: [PATCH] fix common misspelling

---
 ChangeLog                                      |  8 +++---
 compile.c                                      |  2 +-
 cont.c                                         |  6 ++---
 doc/ChangeLog-0.60_to_1.1                      |  6 ++---
 doc/ChangeLog-1.8.0                            |  6 ++---
 doc/ChangeLog-1.9.3                            | 36 +++++++++++++-------------
 doc/ChangeLog-YARV                             | 10 +++----
 doc/contributing.rdoc                          |  2 +-
 ext/tk/lib/tkextlib/SUPPORT_STATUS             |  2 +-
 ext/tk/sample/demos-en/combo.rb                |  2 +-
 ext/tk/sample/demos-en/rolodex                 |  2 +-
 ext/tk/sample/demos-jp/rolodex                 |  2 +-
 ext/tk/sample/tkextlib/blt/pareto.rb           |  2 +-
 ext/tk/sample/tkextlib/tkHTML/page4/index.html |  2 +-
 include/ruby/version.h                         |  2 +-
 man/ruby.1                                     |  4 +--
 test/net/http/test_http.rb                     |  6 ++---
 test/openssl/test_config.rb                    |  2 +-
 test/rexml/test_core.rb                        |  2 +-
 test/webrick/test_httpserver.rb                |  2 +-
 20 files changed, 53 insertions(+), 53 deletions(-)

diff --git a/ChangeLog b/ChangeLog
index be5e334..cfbf52e 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -2702,7 +2702,7 @@ Wed Nov  4 15:40:45 2015  SHIBATA Hiroshi  <hsbt@ruby-lang.org>
 
 Wed Nov  4 15:39:32 2015  SHIBATA Hiroshi  <hsbt@ruby-lang.org>
 
-	* hash.c: use correct grammer. Patch by @tveastman
+	* hash.c: use correct grammar. Patch by @tveastman
 	  [fix GH-1079][ci skip]
 
 Wed Nov  4 11:38:23 2015  Jake Worth  <jakeworth82@gmail.com>
@@ -9552,8 +9552,8 @@ Tue Mar 25 06:55:43 2015  Kazuki Tanaka  <gogotanaka@ruby-lang.org>
 
 Tue Mar 24 22:23:33 2015  SHIBATA Hiroshi  <shibata.hiroshi@gmail.com>
 
-	* doc/extention.rdoc: move from toplevel document and added extname.
-	* doc/extention.ja.rdoc: ditto.
+	* doc/extension.rdoc: move from toplevel document and added extname.
+	* doc/extension.ja.rdoc: ditto.
 
 Tue Mar 24 22:06:58 2015  SHIBATA Hiroshi  <shibata.hiroshi@gmail.com>
 
@@ -11358,7 +11358,7 @@ Tue Jan 20 02:54:11 2015  Zachary Scott  <e@zzak.io>
 
 Mon Jan 19 22:08:26 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>
 
-	* class.c (include_modules_at): allow prepend each modules upto
+	* class.c (include_modules_at): allow prepend each modules up to
 	  once for each classes.  [EXPERIMENTAL]
 
 Sun Jan 18 18:32:20 2015  SHIBATA Hiroshi  <shibata.hiroshi@gmail.com>
diff --git a/compile.c b/compile.c
index ed6f968..c67ae00 100644
--- a/compile.c
+++ b/compile.c
@@ -8221,7 +8221,7 @@ ibf_load_setup(struct ibf_load *load, VALUE loader_obj, VALUE str)
 	rb_raise(rb_eRuntimeError, "broken binary format");
     }
     if (strncmp(load->header->magic, "YARB", 4) != 0) {
-	rb_raise(rb_eRuntimeError, "unkown binary format");
+	rb_raise(rb_eRuntimeError, "unknown binary format");
     }
     if (load->header->major_version != ISEQ_MAJOR_VERSION ||
 	load->header->minor_version != ISEQ_MINOR_VERSION) {
diff --git a/cont.c b/cont.c
index 24b1a4c..8ebd78f 100644
--- a/cont.c
+++ b/cont.c
@@ -137,7 +137,7 @@ struct rb_fiber_struct {
      * then this fiber can't "resume" any more after that.
      * You shouldn't mix "transfer" and "resume".
      */
-    int transfered;
+    int transferred;
 
 #if FIBER_USE_NATIVE
 #ifdef _WIN32
@@ -1507,7 +1507,7 @@ rb_fiber_resume(VALUE fibval, int argc, const VALUE *argv)
     if (fib->prev != 0 || fib->cont.type == ROOT_FIBER_CONTEXT) {
 	rb_raise(rb_eFiberError, "double resume");
     }
-    if (fib->transfered != 0) {
+    if (fib->transferred != 0) {
 	rb_raise(rb_eFiberError, "cannot resume transferred Fiber");
     }
 
@@ -1619,7 +1619,7 @@ rb_fiber_m_transfer(int argc, VALUE *argv, VALUE fibval)
 {
     rb_fiber_t *fib;
     GetFiberPtr(fibval, fib);
-    fib->transfered = 1;
+    fib->transferred = 1;
     return fiber_switch(fib, argc, argv, 0);
 }
 
diff --git a/doc/ChangeLog-0.60_to_1.1 b/doc/ChangeLog-0.60_to_1.1
index a0a138e..33b0326 100644
--- a/doc/ChangeLog-0.60_to_1.1
+++ b/doc/ChangeLog-0.60_to_1.1
@@ -334,7 +334,7 @@ Fri Apr 11 10:27:29 1997  Yukihiro Matsumoto  <matz@caelum.co.jp>
 
 	* eval.c (proc_s_new): save safe-level in the proc context.
 
-	* eval.c (rb_eval): no class/module extention in safe mode.
+	* eval.c (rb_eval): no class/module extension in safe mode.
 
 Thu Apr 10 02:10:41 1997  Yukihiro Matsumoto  <matz@caelum.co.jp>
 
@@ -392,7 +392,7 @@ Thu Apr  3 02:12:31 1997  Yukihiro Matsumoto  <matz@caelum.co.jp>
 	* parse.y (parse_regx): new option //[nes] to specify character
 	  code for regexp literals.  Last specified code option is valid.
 
-	* re.c (reg_s_new): addtional 3rd argument to specify compiled
+	* re.c (reg_s_new): additional 3rd argument to specify compiled
  	  regexp's character code.
 
 	* re.c (reg_new_1): regexp character code can be specified for
@@ -838,7 +838,7 @@ Fri Jan 17 12:31:37 1997  Yukihiro Matsumoto  <matz@caelum.co.jp>
 	* ruby.c (ruby_options): constant PLATFORM, which is in the {cpu}-{os}
 	  form, defined.
 
-	* configure.in: platform infomation embedded in the interpreter.
+	* configure.in: platform information embedded in the interpreter.
 
 	* regex.c (re_search): /^$/ did not match to "" by wrong exit condition.
 
diff --git a/doc/ChangeLog-1.8.0 b/doc/ChangeLog-1.8.0
index 07d7c6b..0d00266 100644
--- a/doc/ChangeLog-1.8.0
+++ b/doc/ChangeLog-1.8.0
@@ -1454,7 +1454,7 @@ Fri Jun 27 03:24:54 2003  Nobuyoshi Nakada  <nobu.nokada@softhome.net>
 Thu Jun 26 21:34:49 2003  Nobuyoshi Nakada  <nobu.nokada@softhome.net>
 
 	* class.c (class_instance_method_list): get rid of warning about
-	  arguement type mismatch, and inline method_list().
+	  argument type mismatch, and inline method_list().
 	  [ruby-core:01198]
 
 Wed Jun 25 14:40:33 2003  Hidetoshi NAGAI <nagai@ai.kyutech.ac.jp>
@@ -3361,7 +3361,7 @@ Fri Apr 11 02:41:35 2003  Nobuyoshi Nakada  <nobu.nokada@softhome.net>
 
 Thu Apr 10 21:12:19 2003  Minero Aoki  <aamine@loveruby.net>
 
-	* lib/net/pop.rb: Exception line was accidentaly removed.
+	* lib/net/pop.rb: Exception line was accidentally removed.
 	  [ruby-dev:19989]
 
 Thu Apr 10 18:42:13 2003  Tadayoshi Funaba  <tadf@dotrb.org>
@@ -5986,7 +5986,7 @@ Thu Nov  7 09:51:37 2002  Nobuyoshi Nakada  <nobu.nokada@softhome.net>
 Wed Nov  6 16:57:06 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>
 
 	* class.c (rb_define_method): do not set NOEX_CFUNC if klass is
-	  really a module, whose methods must be safe for reciever's type.
+	  really a module, whose methods must be safe for receiver's type.
 
 	* eval.c (rb_eval): nosuper should not be inherited unless the
 	  overwritten method is an undef placeholder.
diff --git a/doc/ChangeLog-1.9.3 b/doc/ChangeLog-1.9.3
index e9ede64..b3deb55 100644
--- a/doc/ChangeLog-1.9.3
+++ b/doc/ChangeLog-1.9.3
@@ -3541,7 +3541,7 @@ Sun May 15 23:45:11 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>
 Sun May 15 22:26:39 2011  CHIKANAGA Tomoyuki  <nagachika00@gmail.com>
 
 	* signal.c (rb_f_kill): accept '-SIGXXX' style signal with Symbol or
-	  implicit convertion with #to_str. [ruby-dev:43169] fixes #4362
+	  implicit conversion with #to_str. [ruby-dev:43169] fixes #4362
 	* test/ruby/test_signal.rb (test_signal_process_group): add a test
 	  for send signal to process group.
 
@@ -8041,7 +8041,7 @@ Sat Dec 25 17:33:55 2010  Nobuyoshi Nakada  <nobu@ruby-lang.org>
 	  anonymous classes.
 
 	* lib/csv.rb (CSV#init_separators): use IO#gets with length
-	  parameter to get rid of wrong convertion.
+	  parameter to get rid of wrong conversion.
 
 	* lib/csv.rb (CSV::foreach, CSV#initialize): directly use encoding
 
@@ -8382,7 +8382,7 @@ Tue Dec 14 14:24:15 2010  NAKAMURA Usaku  <usa@ruby-lang.org>
 	  to 'test_io' because the old one is meaningless and inconvenient.
 
 	* test/ruby/test_io.rb (test_binmode_after_closed): the temporary file
-	  maked by make_temfile is already closed.
+	  made by make_temfile is already closed.
 
 Tue Dec 14 13:52:19 2010  NAKAMURA Usaku  <usa@ruby-lang.org>
 
@@ -22363,7 +22363,7 @@ Tue Sep 29 22:19:36 2009  Tanaka Akira  <akr@fsij.org>
 
 Tue Sep 29 21:16:35 2009  NARUSE, Yui  <naruse@ruby-lang.org>
 
-	* io.c (rb_scan_open_args): add UTF8-MAC to no-convertion encoding.
+	* io.c (rb_scan_open_args): add UTF8-MAC to no-conversion encoding.
 
 Tue Sep 29 21:21:15 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>
 
@@ -33712,7 +33712,7 @@ Thu Dec 25 14:51:43 2008  NAKAMURA Usaku  <usa@ruby-lang.org>
 Thu Dec 25 14:32:23 2008  Koichi Sasada  <ko1@atdot.net>
 
 	* vm_insnhelper.c (vm_method_search): fix control flow bug.
-	  (commited at r20981)
+	  (committed at r20981)
 
 Thu Dec 25 13:28:20 2008  NAKAMURA Usaku  <usa@ruby-lang.org>
 
@@ -71774,7 +71774,7 @@ Wed Mar  1 17:13:37 2006  Yukihiro Matsumoto  <matz@ruby-lang.org>
 
 Thu Mar  2 17:54:45 2006  Hirokazu Yamamoto  <ocean@m2.ccsnet.ne.jp>
 
-	* gc.c: commited magic for reducing RVALUE size on windows. (24->20byte)
+	* gc.c: committed magic for reducing RVALUE size on windows. (24->20byte)
 	  [ruby-core:7474]
 
 Thu Mar  2 14:12:26 2006  Tanaka Akira  <akr@m17n.org>
@@ -73761,7 +73761,7 @@ Fri Oct 21 15:42:28 2005  Hirokazu Yamamoto  <ocean@m2.ccsnet.ne.jp>
 
 	* ext/socket/extconf.rb: BeOS is only one platform should call
 	  closesocket, so check __BEOS__ macro directly. (I was worried
-	  accidently HAVE_CLOSESOCKET is defined on windows again because
+	  accidentally HAVE_CLOSESOCKET is defined on windows again because
 	  it has it)
 
 	* ext/socket/{getaddrinfo.c,socket.c}: ditto.
@@ -73770,7 +73770,7 @@ Fri Oct 21 15:42:28 2005  Hirokazu Yamamoto  <ocean@m2.ccsnet.ne.jp>
 
 Fri Oct 21 15:23:23 2005  Hirokazu Yamamoto  <ocean@m2.ccsnet.ne.jp>
 
-	* bignum.c (bignew_1): convertion from `int' to `char' discards
+	* bignum.c (bignew_1): conversion from `int' to `char' discards
 	  upper bits, (ie. (char)0xff00 -> 0) so it's better to test if
 	  nonzero and set 0 or 1 instead of simply casting ... as a flag usage.
 	  (but I believe this won't cause actual bug in current implementation)
@@ -74937,7 +74937,7 @@ Mon Sep 12 20:32:00 2005  Hirokazu Yamamoto  <ocean@m2.ccsnet.ne.jp>
 
 Mon Sep 12 19:58:53 2005  Hirokazu Yamamoto  <ocean@m2.ccsnet.ne.jp>
 
-	* dln.c: avoid warning of const to non-const convertion.
+	* dln.c: avoid warning of const to non-const conversion.
 	  [ruby-dev:27041]
 
 	* eval.c, io.c, ruby.c: ditto.
@@ -83155,7 +83155,7 @@ Thu Aug 19 16:29:45 2004  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>
 
 	* ext/tk/lib/tk.rb: Fail to treat a hash value of 'font' option.
 
-	* ext/tk/lib/tk.rb: bindinfo cannot return '%' substiturion infomation.
+	* ext/tk/lib/tk.rb: bindinfo cannot return '%' substiturion information.
 
 	* ext/tk/lib/menu.rb: typo bug.
 
@@ -83584,7 +83584,7 @@ Wed Jul 14 18:05:21 2004  GOTOU Yuuzou  <gotoyuzo@notwork.org>
 Wed Jul 14 12:20:05 2004  Hirokazu Yamamoto  <ocean@m2.ccsnet.ne.jp>
 
 	* util.c (ruby_strtod): should not convert string in the form of
-	  "-I.FE-X" which both "I" and "F" are ommitted. [ruby-dev:23883]
+	  "-I.FE-X" which both "I" and "F" are omitted. [ruby-dev:23883]
 
 	* test/ruby/test_float.rb (test_strtod): add test for bug fix.
 
@@ -84298,7 +84298,7 @@ Sat May 22 11:54:10 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>
 
 Sat May 22 05:37:11 2004  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>
 
-	* ext/tk/lib/remote-tk.rb: (NEW library) controll Tk interpreters
+	* ext/tk/lib/remote-tk.rb: (NEW library) control Tk interpreters
 	  on the other processes by Tcl/Tk's 'send' command
 
 Fri May 21 09:22:05 2004  Dave Thomas  <dave@pragprog.com>
@@ -85607,10 +85607,10 @@ Wed Mar 17 00:22:03 2004  Kazuo Saito  <ksaito@uranus.dti.ne.jp>
 Tue Mar 16 11:14:17 2004  Hirokazu Yamamoto  <ocean@m2.ccsnet.ne.jp>
 
 	* dir.c (fnmatch_helper): File.fnmatch('\.', '.') should return true.
-	  (Rev1.112 lost compatiblity)
+	  (Rev1.112 lost compatibility)
 
 	* dir.c (fnmatch_helper): File.fnmatch('\/', '/', File::FNM_PATHNAME)
-	  should return true. (Rev1.112 lost compatiblity)
+	  should return true. (Rev1.112 lost compatibility)
 
 	* dir.c (fnmatch): File.fnmatch('**/.boo', '.foo/.boo',
 	  File::FNM_PATHNAME) should return false because of leading period.
@@ -86434,7 +86434,7 @@ Mon Feb 16 22:22:00 2004  Gavin Sinclair  <gsinclair@soyabean.com.au>
 
 Mon Feb 16 20:28:52 2004  Hirokazu Yamamoto  <ocean@m2.ccsnet.ne.jp>
 
-	* bcc32/Makefile.sub: show more warnings. (refering to mingw)
+	* bcc32/Makefile.sub: show more warnings. (referring to mingw)
 
 	* bcc32/setup.mak: ditto.
 
@@ -86492,7 +86492,7 @@ Mon Feb 16 12:29:10 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>
 Mon Feb 16 10:29:52 2004  Hirokazu Yamamoto  <ocean@m2.ccsnet.ne.jp>
 
 	* dir.c (CompareImpl): File.fnmatch and Dir.glob get better performance
-	  in Win32. This is achived by calling downcase() for single-byte
+	  in Win32. This is achieved by calling downcase() for single-byte
 	  characters. (CharLower() is slower than downcase())
 
 Mon Feb 16 02:14:29 2004  Hirokazu Yamamoto  <ocean@m2.ccsnet.ne.jp>
@@ -86561,7 +86561,7 @@ Sat Feb 14 11:14:12 2004  Masatoshi SEKI  <m_seki@mva.biglobe.ne.jp>
 
 Fri Feb 13 21:51:00 2004  Gavin Sinclair  <gsinclair@soyabean.com.au>
 
-	* lib/fileutils.rb: slighly improved documentation (sync with 1.8)
+	* lib/fileutils.rb: slightly improved documentation (sync with 1.8)
 
 Fri Feb 13 19:57:01 2004  Kouhei Sutou  <kou@cozmixng.org>
 
@@ -89179,7 +89179,7 @@ Thu Nov 27 22:05:48 2003  Akinori MUSHA  <knu@iDaemons.org>
 Thu Nov 27 17:36:42 2003  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>
 
 	* ext/tk/lib/tkafter.rb: bug fix on TkTimer#cancel_on_exception=(mode).
-	  TkTimer#wait recieves the exception of the callback.
+	  TkTimer#wait receives the exception of the callback.
 	  The exception is kept on @return_value.
 
 Thu Nov 27 16:58:48 2003  WATANABE Hirofumi  <eban@ruby-lang.org>
diff --git a/doc/ChangeLog-YARV b/doc/ChangeLog-YARV
index 5298545..6a6cfbd 100644
--- a/doc/ChangeLog-YARV
+++ b/doc/ChangeLog-YARV
@@ -2428,7 +2428,7 @@ Sun Dec 31 17:42:05 2006  Koichi Sasada  <ko1@atdot.net>
 2006-02-14(Tue) 05:53:56 +0900  Minero Aoki  <aamine@loveruby.net>
 
 	* eval.c (ruby_cleanup): th->errinfo contains a NODE while
-	  break'ing, check it before refering klass.
+	  break'ing, check it before referring klass.
 
 
 2006-02-14(Tue) 05:45:07 +0900  Koichi Sasada  <ko1@atdot.net>
@@ -2461,7 +2461,7 @@ Sun Dec 31 17:42:05 2006  Koichi Sasada  <ko1@atdot.net>
 
 2006-02-14(Tue) 01:42:11 +0900  Koichi Sasada  <ko1@atdot.net>
 
-	* error.c : fix include file positon
+	* error.c : fix include file position
 
 	* test/ruby/test_signal.rb : skip test_exit_action on cygwin
 
@@ -6168,7 +6168,7 @@ Sun Dec 31 17:42:05 2006  Koichi Sasada  <ko1@atdot.net>
 
 	* test.rb : restore $" after evaluation with ruby
 
-	* rb/insns2vm.rb : remove unnecesary each
+	* rb/insns2vm.rb : remove unnecessary each
 
 
 2004-12-17(Fri) 18:56:38 +0900  Koichi Sasada  <ko1@atdot.net>
@@ -6397,7 +6397,7 @@ Sun Dec 31 17:42:05 2006  Koichi Sasada  <ko1@atdot.net>
 
 	* vm.c : fix stack dump routine
 
-	* vm.c : impliment thread_funcall (temporarily)
+	* vm.c : implement thread_funcall (temporarily)
 
 	* yarv.h : add IS_YARV_WORKING(), SET_YARV_START(), SET_YARV_STOP()
 
@@ -6590,7 +6590,7 @@ Sun Dec 31 17:42:05 2006  Koichi Sasada  <ko1@atdot.net>
 	* yarvcore.h, yarvcore.c : add idThrow*
 
 	* insns.def, compile.c, vm.c : support retry, break,
-	next, redo, return(imcomplete)
+	next, redo, return(incomplete)
 
 
 2004-09-03(Fri) 13:40:08 +0900  Koichi Sasada  <ko1@atdot.net>
diff --git a/doc/contributing.rdoc b/doc/contributing.rdoc
index 6176ba6..898f117 100644
--- a/doc/contributing.rdoc
+++ b/doc/contributing.rdoc
@@ -459,7 +459,7 @@ tracker. Alternatively you can submit a pull request, but for the best chances
 to receive feedback add it is recommended you add it to redmine.
 
 Since git is a distributed system, you are welcome to host your git repository
-on any {publically accessible hosting
+on any {publicly accessible hosting
 site}[https://git.wiki.kernel.org/index.php/GitHosting], including {hosting your
 own}[https://www.kernel.org/pub/software/scm/git/docs/user-manual.html#public-repositories]
 You may use the {'git format-patch'}[http://git-scm.com/docs/git-format-patch]
diff --git a/ext/tk/lib/tkextlib/SUPPORT_STATUS b/ext/tk/lib/tkextlib/SUPPORT_STATUS
index de51c51..b44b629 100644
--- a/ext/tk/lib/tkextlib/SUPPORT_STATUS
+++ b/ext/tk/lib/tkextlib/SUPPORT_STATUS
@@ -4,7 +4,7 @@
   *** RELEASE_DATE of the libraries => see 'tkextlib/version.rb' ***
 
 The following list shows *CURRENT* status when this file was modified
-at last. If you want to add other Tcl/Tk extensions to the planed list
+at last. If you want to add other Tcl/Tk extensions to the planned list
 (or change its status position), please request them at the ruby-talk,
 ruby-list, or ruby-dev ML. Although we cannot promise to support your
 requests, we'll try to do.
diff --git a/ext/tk/sample/demos-en/combo.rb b/ext/tk/sample/demos-en/combo.rb
index 2f2dd5d..b8bf2d8 100644
--- a/ext/tk/sample/demos-en/combo.rb
+++ b/ext/tk/sample/demos-en/combo.rb
@@ -72,7 +72,7 @@
 ]
 
 
-secondValue.value = 'unchangable'
+secondValue.value = 'unchangeable'
 ozCity.value = 'Sydney'
 
 Tk.pack(Ttk::Labelframe.new(frame, :text=>'Fully Editable'){|f|
diff --git a/ext/tk/sample/demos-en/rolodex b/ext/tk/sample/demos-en/rolodex
index dfc4b2b..b4c42b6 100644
--- a/ext/tk/sample/demos-en/rolodex
+++ b/ext/tk/sample/demos-en/rolodex
@@ -284,7 +284,7 @@ $helpTopics["context"] = <<EOF
 Unfortunately, this application doesn't support context-sensitive\
 help in the usual way, because when this demo was written Ruby/Tk\
 didn't have a grab mechanism and this is needed for context-sensitive\
-help. Instead, you can achive much the same effect by simply moving\
+help. Instead, you can achieve much the same effect by simply moving\
 the mouse over the window you're curious about and pressing the\
 Help or F1 keys. You can do this anytime.
 EOF
diff --git a/ext/tk/sample/demos-jp/rolodex b/ext/tk/sample/demos-jp/rolodex
index 2cc73e1..95c0e3b 100644
--- a/ext/tk/sample/demos-jp/rolodex
+++ b/ext/tk/sample/demos-jp/rolodex
@@ -284,7 +284,7 @@ $helpTopics["context"] = <<EOF
 Unfortunately, this application doesn't support context-sensitive\
 help in the usual way, because when this demo was written Ruby/Tk\
 didn't have a grab mechanism and this is needed for context-sensitive\
-help. Instead, you can achive much the same effect by simply moving\
+help. Instead, you can achieve much the same effect by simply moving\
 the mouse over the window you're curious about and pressing the\
 Help or F1 keys. You can do this anytime.
 EOF
diff --git a/ext/tk/sample/tkextlib/blt/pareto.rb b/ext/tk/sample/tkextlib/blt/pareto.rb
index 987be45..e68cde7 100644
--- a/ext/tk/sample/tkextlib/blt/pareto.rb
+++ b/ext/tk/sample/tkextlib/blt/pareto.rb
@@ -68,7 +68,7 @@
                   :foreground=>'red4', :anchor=>:center, :yoffset=>-5)
 }
 
-# Display an auxillary y-axis for percentages.
+# Display an auxiliary y-axis for percentages.
 b.axis_configure('y2', :hide=>false, :min=>0.0, :max=>100.0,
                  :title=>'Percentage')
 
diff --git a/ext/tk/sample/tkextlib/tkHTML/page4/index.html b/ext/tk/sample/tkextlib/tkHTML/page4/index.html
index c7bfde3..588ae5c 100644
--- a/ext/tk/sample/tkextlib/tkHTML/page4/index.html
+++ b/ext/tk/sample/tkextlib/tkHTML/page4/index.html
@@ -117,7 +117,7 @@ squelching curiosity."
 <B><FONT SIZE="+2">nmpg 1.1.3</FONT></B><BR>
 <SMALL><B><A HREF="mailto:narkos@linuxmail.org">Joel Lindau</A> - January 29th 2000, 18:18 EST</B></SMALL>
 <DIV ALIGN="justify"><P>nmpg is a small command-driven frontend and network-jukebox for mpg123.</DIV>
-<P><B>Changes:</B> Bugfixes, better memory managment, a new .nmpgrc parser, and new options.
+<P><B>Changes:</B> Bugfixes, better memory management, a new .nmpgrc parser, and new options.
 <P><B>Urgency:</B> low
 <P ALIGN="right"><B>[ <A HREF="/news/2000/01/29/949187896.html">comments (0)</A> ]</B>
 </FONT></TD></TR></TABLE></TD></TR><TR><TD VALIGN="middle">
diff --git a/include/ruby/version.h b/include/ruby/version.h
index 8cc3c8c..bb1926f 100644
--- a/include/ruby/version.h
+++ b/include/ruby/version.h
@@ -13,7 +13,7 @@
 
 /*
  * This file contains only
- * - never-changable informations, and
+ * - never-changeable informations, and
  * - interfaces accessible from extension libraries.
  *
  * Never try to check RUBY_VERSION_CODE etc in extension libraries,
diff --git a/man/ruby.1 b/man/ruby.1
index 560a536..e63521c 100644
--- a/man/ruby.1
+++ b/man/ruby.1
@@ -506,14 +506,14 @@ as below.
 .Pp
 .Sh GC ENVIRONMENT
 The Ruby garbage collector (GC) tracks objects in fixed-sized slots,
-but each object may have auxillary memory allocations handled by the
+but each object may have auxiliary memory allocations handled by the
 malloc family of C standard library calls (
 .Xr malloc 3 ,
 .Xr calloc 3 ,
 and
 .Xr realloc 3 ) .
 In this documentatation, the "heap" refers to the Ruby object heap
-of fixed-sized slots, while "malloc" refers to auxillary
+of fixed-sized slots, while "malloc" refers to auxiliary
 allocations commonly referred to as the "process heap".
 Thus there are at least two possible ways to trigger GC:
 .Bl -hang -offset indent
diff --git a/test/net/http/test_http.rb b/test/net/http/test_http.rb
index d8983e9..f1d3ede 100644
--- a/test/net/http/test_http.rb
+++ b/test/net/http/test_http.rb
@@ -151,12 +151,12 @@ def test_proxy_eh_ENV_no_proxy
 
   def test_proxy_port
     clean_http_proxy_env do
-      http = Net::HTTP.new 'exmaple', nil, 'proxy.example'
+      http = Net::HTTP.new 'example', nil, 'proxy.example'
       assert_equal 'proxy.example', http.proxy_address
       assert_equal 80, http.proxy_port
-      http = Net::HTTP.new 'exmaple', nil, 'proxy.example', 8000
+      http = Net::HTTP.new 'example', nil, 'proxy.example', 8000
       assert_equal 8000, http.proxy_port
-      http = Net::HTTP.new 'exmaple', nil
+      http = Net::HTTP.new 'example', nil
       assert_equal nil, http.proxy_port
     end
   end
diff --git a/test/openssl/test_config.rb b/test/openssl/test_config.rb
index 8f5bdb2..1a5dfe6 100644
--- a/test/openssl/test_config.rb
+++ b/test/openssl/test_config.rb
@@ -168,7 +168,7 @@ def test_get_value_ENV
   end
 
   def test_value
-    # supress deprecation warnings
+    # suppress deprecation warnings
     OpenSSL::TestUtils.silent do
       assert_equal('CA_default', @it.value('ca', 'default_ca'))
       assert_equal(nil, @it.value('ca', 'no such key'))
diff --git a/test/rexml/test_core.rb b/test/rexml/test_core.rb
index f4eba0b..0071063 100644
--- a/test/rexml/test_core.rb
+++ b/test/rexml/test_core.rb
@@ -619,7 +619,7 @@ def test_stream
       File.open(fixture_path("documentation.xml")) do |f|
         Document.parse_stream( f, c )
       end
-      assert(c.ts, "Stream parsing apparantly didn't parse the whole file")
+      assert(c.ts, "Stream parsing apparently didn't parse the whole file")
       assert(c.te, "Stream parsing dropped end tag for documentation")
 
       Document.parse_stream("<a.b> <c/> </a.b>", c)
diff --git a/test/webrick/test_httpserver.rb b/test/webrick/test_httpserver.rb
index e718738..5adf617 100644
--- a/test/webrick/test_httpserver.rb
+++ b/test/webrick/test_httpserver.rb
@@ -360,7 +360,7 @@ def test_response_io_without_chunked_set
           http.request(req){|res| assert_equal("foo", res.body) }
         end
       rescue Timeout::Error
-        flunk('corrupted reponse')
+        flunk('corrupted response')
       end
     }
   end
-- 
2.1.4